#include<iostream.h>
#include<fstream.h>
#include"harm.cxx"
#include"color.cxx"
#include<math.h>
#include<stdio.h>
#include<stdlib.h>

const int xDim=256;
const int yDim=256;

void getPointer(double &a, double &b, double &c, int x, int y){
  double phi, theta, t;
 
  phi = (double)y/(yDim-1.0)*M_PI;
  theta = (double)x/(xDim-1.0)*2.0*M_PI;
 
  b=cos(M_PI-phi);
  t=tan(3.0/2.0*M_PI-theta);
  a=sqrt((1.0-b*b)/(1.0+t*t));
  if (theta<M_PI && theta>=0.0) a=-a;
  c=a*t;
 
  return;
}      

int main(){
   int l, m;
   double p, t;
   double a, b, c;
   int x, y;
   int steps=150;
   char gifcmd[200];
   ofstream ppm;
   double h;

   for (l=0;l<=5;l++)
      for (m=-l;m<=l;m++){
	 // open ppm file
	 sprintf(gifcmd, "ppmtogif img2.ppm > pics/%1il%1im.gif", l, m);
	 ppm.open("img.ppm");
         ppm.precision(10);
	 ppm << "P3\n" << xDim << " " << yDim << "\n255\n";
	 
	 // write values
	 for (y=yDim-1; y>=0; y--){
	   for (x=0; x<xDim; x++){
	     getPointer(a,b,c,x,y);
	     h=sqrt(harm(a,b,c,l,m));
	     // convert h to RGB
	     float r, g, b;
	     HSVtoRGB(&r, &g, &b, h*360.0, 1.0,
		      sqrt(1.0-pow(h-1.0,2.0)));
	     ppm << (int)(r*255.0) << " ";
	     ppm << (int)(g*255.0) << " ";
	     ppm << (int)(b*255.0) << "\n";
	   }
	 }
	   
	 /*
	 for (p=0; p<=M_PI; p+=M_PI/steps){
	   for (t=0; t<=2*M_PI; t+=2*M_PI/steps){
	      h=sqrt(harm(p,t,l,m));
	      // convert h to RGB
	      float r, g, b;
	      HSVtoRGB(&r, &g, &b, h*360.0, 1.0, sqrt(1.0-pow(h-1.0,2.0)));
	      ppm << (int)(r*255.0) << " ";
	      ppm << (int)(g*255.0) << " ";
	      ppm << (int)(b*255.0) << "\n";
	   }
	 }
	 */
	 
	 ppm.close();

	 // convert ppm to gif
	 system("ppmquant 256 img.ppm >img2.ppm");
	 system(gifcmd);  
         system("rm img.ppm");
	 system("rm img2.ppm");
      }
   
   return(0);
}
